"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const mails_1 = require("../entities/mails");
const mysqlConn_1 = __importDefault(require("../connections/mysqlConn"));
const nodemailer_1 = __importDefault(require("nodemailer"));
const create = async (req, res) => {
    console.log('se invoca el servicio crear correo', new Date(Date.now()).toLocaleString());
    const { mailer, section, subject, message, user, phone } = req.body;
    const mails = new mails_1.Mails(mailer, section, subject, message, user, phone);
    if (!mails) {
        return res.json({ message: 'Error fomato correo' });
    }
    /**
     * Se realiza el envio y se guarda en base de datos
     */
    const transporter = nodemailer_1.default.createTransport({
        host: 'mail.institutodeltorax.com',
        port: 465,
        secure: true,
        requireTLS: false,
        auth: {
            user: 'info@institutodeltorax.com',
            pass: 'CBNJd4RP(!dC',
        },
    });
    await transporter
        .sendMail({
        from: 'Contacto desde <info@institutodeltorax.com>',
        to: 'info@institutodeltorax.com',
        subject: `[${mails.getSection()}] ${mails.getSubject()}`,
        html: `<p>Sección: ${mails.getSection()}</p>
                <p>Nombre: ${mails.getUser()}</p>
                <p>Correo: ${mails.getMailer()}</p>
                <p>Teléfono: ${mails.getPhone()}</p>
                <p>Mensaje: ${mails.getMessage()}</p>`,
    })
        .then(async (info) => {
        await mysqlConn_1.default.query('INSERT INTO mails SET ?,?', [mails, { state: 1, error: info.response }], function (err, result, fields) {
            if (err) {
                res.json(err);
            }
            res.json({ message: 'email enviado con éxito' });
        });
    })
        .catch(async (error) => {
        await mysqlConn_1.default.query('INSERT INTO mails SET ?,?', [mails, { state: 0, error: error }], function (err, result, fields) {
            if (err) {
                res.json(err);
            }
            res.json({ message: `se presento error en el envio` });
        });
    });
};
exports.create = create;
