import { Router } from 'express';
import documentRouter from './src/routers/documentRouter';
import campaigRouter from './src/routers/campaigRouter';
import mailRouter from './src/routers/mailRouter';

const routers = Router();

routers.use('/documents', documentRouter);
routers.use('/campaig', campaigRouter);
routers.use('/mails', mailRouter);

export default routers;

